
#DEFINE DUREE_ERR_CAL	.20
#DEFINE	LCD16X2		1		; afficheur 2 lignes de 16

	INCLUDE "lcd_cmn.inc"
	INCLUDE	"lcd_4bit.inc"

DISPLAY_MESSAGE:
	
	; affiche un message sur la premire ligne du LCD
	; W doit contenir le code identifiant le message
	
	movwf	temporaire	
	movlw	0x00
	call	LCD_MOVECURS
	clrf	FSR

	movlw	HIGH DEBUT_MESSAGES	; !!! attention !!! pour gagner du code
	movwf	PCLATH

display_message_loop:

	movlw	CODE_MESSAGE_CAL
	xorwf	temporaire,W
	btfsc	_Z
	goto	call_message_cal

	movlw	CODE_MESSAGE_INVITE
	xorwf	temporaire,W
	btfsc	_Z
	goto	call_message_invite

	movlw	CODE_MESSAGE_ERRCAL
	xorwf	temporaire,W
	btfsc	_Z
	goto	call_message_errcal
	return

call_message_invite:
	movf	FSR,W
	call	MESSAGE_INVITE
	goto	display_message_end

call_message_cal:
	movf	FSR,W
	call	MESSAGE_CAL
	goto	display_message_end

call_message_errcal:
	movf	FSR,W
	call	MESSAGE_ERRCAL

display_message_end:
	iorlw	.0
	btfsc	_Z
	return

	ifndef	LCD16X2
	 movwf	cptr
	 movlw	8			; 1 ligne de 16: caractre 8  l'adresse 0x40
	 xorwf	FSR,W
	 btfss	_Z
	 goto	display_16X1
	 movlw	0x40
	 call	LCD_MOVECURS
display_16X1:
	 movf	cptr,W
	endif

	call	LCD_PUTCH
	incf	FSR,f			; incrmentation compteur de boucle
	goto	display_message_loop

DISPLAY_RDSON:
	
	; affiche le RDSon du transistor JFET

	ifdef	LCD16X2
	movlw	.10
	else	
	movlw	0x42
	endif

	call	LCD_MOVECURS		; 11ime caractre
	movlw	'r'
	call	LCD_PUTCH
	
	movlw	'='
	call	LCD_PUTCH
	
	call	DISPLAY_DECIMAL

	movlw	0xF4			; ohm
	call	LCD_PUTCH
	
	return

DISPLAY_RESISTANCE:

	movlw	0x00
	call	LCD_MOVECURS		; 1er caractre
	movlw	'R'
	call	LCD_PUTCH
	movlw	'E'
	call	LCD_PUTCH
	movlw	'S'
	call	LCD_PUTCH

	movlw	0x05
	call	LCD_MOVECURS		; 6ime caractre

	movlw	'-'
	call	LCD_PUTCH

	movlw	0x04
	call	LCD_MOVECURS		; 5ime caractre

	movlw	'M'
	btfss	FSR,2
	movlw	'G'
	call	LCD_PUTCH

	movlw	0x06
	call	LCD_MOVECURS		; 7ime caractre

	movlw	'D'
	btfsc	FSR,0
	movlw	'M'
	call	LCD_PUTCH
	
	; affiche la valeur de la rsistance srie
	
	movlw	0x40
	
	call	LCD_MOVECURS		; 9ime caractre
	call	DISPLAY_DECIMAL
		
	movlw	' '
	call	LCD_PUTCH
	
	movlw	0xF4			; ohm
	call	LCD_PUTCH
	
	return

DISPLAY_TYPE_TRANSISTOR:
	
	; affiche le type de transistor sur l'ecran LCD
	; W=1:NPN W=2:PNP W=3:???
	
	movwf	FSR
	decf	FSR,f			; 0, 1, ...
	bcf	_C
	rlf	FSR,f
	rlf	FSR,f
	ifdef LCD16X2
	rlf	FSR,f
	endif
	movlw	HIGH TABLE_TYPE_TRANSISTOR
	movwf	PCLATH
	
	ifdef	LCD16X2
	movlw	8
	else
	movlw	3
	endif
	movwf	temporaire		; compteur de boucle
	movlw	0
	call	LCD_MOVECURS		; 1er caractre

loop_type_transistor:
	movf	FSR,W
	call	TABLE_TYPE_TRANSISTOR
	call	LCD_PUTCH
	incf	FSR,f
	decf	temporaire,f
	btfss	_Z
	goto	loop_type_transistor
	return

DISPLAY_BROCHAGE_TRANSISTOR:
	
	; affiche le brochage du transistor
	; pin_left, pin_middle, pin_right contiennent le brochage (caractres)
	
	ifdef	LCD16X2
	movlw	0X44
	else
	movlw	0x04
	endif

	call	LCD_MOVECURS		; 5ime caractre
	movf	pin_left,W
	call	LCD_PUTCH
	
	movlw	'-'
	call	LCD_PUTCH
	
	movf	pin_middle,W
	call	LCD_PUTCH
	
	movlw	'-'
	call	LCD_PUTCH
	
	ifndef	LCD16X2
	movlw	0x40			; pour afficheur 1 x 16
	call	LCD_MOVECURS		; 9ime caractre
	endif
	movf	pin_right,W
	call	LCD_PUTCH
	return

DISPLAY_BETA_TRANSISTOR:
	
	; affiche le beta du transistor
	
	ifdef   LCD16X2
	movlw	.10
	else
	movlw	0x42
	endif
	call	LCD_MOVECURS		; 11ime caractre
	movlw	0xE2
	call	LCD_PUTCH
	
	movlw	'='
	call	LCD_PUTCH
	
	call	DISPLAY_DECIMAL
	
	movlw	' '
	call	LCD_PUTCH

	return

DISPLAY_VTH:
	
	; affiche la tension de seuil des mosfets
	
	ifdef   LCD16X2
	movlw	.10
	else
	movlw	0x42
	endif

	call	LCD_MOVECURS
	
	call	DISPLAY_DECIMAL_DOT
	
	movlw	' '
	call	LCD_PUTCH

	movlw	'V'
	call	LCD_PUTCH

	return

DISPLAY_DECIMAL_DOT:

	movf	decimal_100,W
	call	LCD_PUTCH

	movlw	'.'
	call	LCD_PUTCH

	goto	display_decimal_01

DISPLAY_DECIMAL:

	; affiche la valeur contenue dans decimal_100 .. decimal_1
	;  la position courante du curseur

	movf	decimal_100,W
	call	LCD_PUTCH

display_decimal_01:

	movf	decimal_10,W
	call	LCD_PUTCH

	movf	decimal_1,W
	call	LCD_PUTCH

	return
