; Routines mathmatiques et de formattage diverses
; 
; Date: 7/10/2003
; 
; By M. Waleczek
;
;
 
BINAIRE_TO_DECIMAL:
	;
	; conversion d'une valeur binaire contenue dans data_h et data_l
	; en une valeur decimale contenue dans decimal_1, decimal_10, decimal_1000
	;
	clrf	decimal_1
	clrf	decimal_10
	clrf	decimal_100
	movlw	0x01			; init masque
	movwf	masque
	movwf	cptr
b2d_loop1:
	movf	masque,W
	andwf	data_l,W
	btfsc	STATUS,Z
	goto	b2d_b
	;
	movlw	LOW TABLE_UNITE
	addwf	cptr,w
	movwf	temporaire		; sauvegarde temporaire
	movlw	HIGH TABLE_UNITE
	btfsc	STATUS,C
	addlw	1
	movwf	PCLATH
	movf	temporaire,W
	call	TABLE_UNITE
	addwf	decimal_1,f
	;
	movlw	LOW TABLE_DIZAINE
	addwf	cptr,w
	movwf	temporaire
	movlw	HIGH TABLE_DIZAINE
	btfsc	STATUS,C
	addlw	1
	movwf	PCLATH
	movf	temporaire,W
	call	TABLE_DIZAINE
	addwf	decimal_10,f
	;
	movlw	LOW TABLE_CENTAINE
	addwf	cptr,w
	movwf	temporaire
	movlw	HIGH TABLE_CENTAINE
	btfsc	STATUS,C
	addlw	1
	movwf	PCLATH
	movf	temporaire,W
	call	TABLE_CENTAINE
	addwf	decimal_100,f
	;
	; gestion des retenues
	;
	movlw	.10
	subwf	decimal_1,W
	btfss	STATUS,C
	goto	b2d_a
	incf	decimal_10,f		; incrmentation des dizaines
	movwf	decimal_1		; 10 en moins sur les units
b2d_a:
	movlw	.10
	subwf	decimal_10,W
	btfss	STATUS,C
	goto	b2d_b
	incf	decimal_100,f		; incrmentation des centaines
	movwf	decimal_10		; 10 en moins sur les dizaines
b2d_b:
	movlw	.10
	subwf	cptr,W
	btfsc	STATUS,C
	goto	b2d_c			; saut si termin
	;
	btfss	masque,7
	goto	b2d_b1
	movlw	.1
	movwf	masque			; rinitialisation du masque
	movf	data_h,W
	movwf	data_l			; data_l prend la valeur de data_h
	goto	b2d_b2			; et c'est reparti
b2d_b1:
	bcf	STATUS,C
	rlf	masque,f
b2d_b2:
	incf	cptr,f
	goto	b2d_loop1

b2d_c:
	clrf	masque
	movf	decimal_100,f
	btfss	STATUS,Z
	goto	b2d_d
	;
	; suppression du zero des centaines inutile
	;
	movlw	.1
	movwf	masque
	movlw	' '
	movwf	decimal_100
	goto	b2d_d1
b2d_d:
	movlw	'0'
	addwf	decimal_100,f
	;
b2d_d1:
	movf	decimal_10,f
	btfss	STATUS,Z
	goto	b2d_e
	;
	; suppression du zero inutile si zero des centaines effac (masque = 1)
	;
	movf	masque,f
	btfsc	STATUS,Z
	goto	b2d_e
	movlw	' '
	movwf	decimal_10
	goto	b2d_e1
b2d_e:
	movlw	'0'
	addwf	decimal_10,f
b2d_e1:
	movlw	'0'
	addwf	decimal_1,f
	return

TABLE_UNITE:
	movwf	PCL
	DT	1,2,4,8,6,2,4,8,6,2

TABLE_DIZAINE:
	movwf	PCL
	DT	0,0,0,0,1,3,6,2,5,1

TABLE_CENTAINE:
	movwf	PCL
	DT	0,0,0,0,0,0,0,1,2,5


UMUL1608L        macro

;       Max Timing:     2+13+6*15+14 = 119 clks
;       Min Timing:     2+7*6+5+4 = 54 clks
;       PM: 26            DM: 7

                MOVLW   0x08
                MOVWF   LOOPCOUNT

LOOPUM1608A
                RRF     BARGB0, F
                BTFSC   _C
                GOTO    LUM1608NAP
                DECFSZ  LOOPCOUNT, F
                GOTO    LOOPUM1608A

                CLRF    AARGB0
                CLRF    AARGB1
                RETLW   0x00

LUM1608NAP
                BCF     _C
                GOTO    LUM1608NA

LOOPUM1608
                RRF     BARGB0, F
                BTFSS   _C
                GOTO    LUM1608NA
                MOVF    TEMPB1,W
                ADDWF   AARGB1, F
                MOVF    TEMPB0,W
                BTFSC   _C
                INCFSZ  TEMPB0,W
                ADDWF   AARGB0, F
LUM1608NA       RRF     AARGB0, F
                RRF     AARGB1, F
                RRF     AARGB2, F
                DECFSZ  LOOPCOUNT, F
                GOTO    LOOPUM1608
                endm

UDIV2315L       macro

;       Max Timing:     9+6*17+16+16+6*17+16+16+6*17+16+8 = 403 clks
;       Min Timing:     9+6*16+15+15+6*16+15+15+6*16+15+3 = 375 clks
;       PM: 7+2*40+22+8 = 117                                    DM: 7

                MOVF            BARGB1,W
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                BTFSS           _C
                INCFSZ          BARGB0,W
                SUBWF           REMB0, F
                RLF             AARGB0, F

                MOVLW           7
                MOVWF           LOOPCOUNT

LOOPU2315A      RLF             AARGB0,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB0,LSB
                GOTO            UADD35LA

                SUBWF           REMB1, F
                MOVF            BARGB0,W
                BTFSS           _C
                INCFSZ          BARGB0,W
                SUBWF           REMB0, F
                GOTO            UOK35LA

UADD35LA        ADDWF           REMB1, F
                MOVF            BARGB0,W
                BTFSC           _C
                INCFSZ          BARGB0,W
                ADDWF           REMB0, F
        
UOK35LA 	RLF             AARGB0, F

                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU2315A

                RLF             AARGB1,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB0,LSB
                GOTO            UADD35L8

                SUBWF           REMB1, F
                MOVF            BARGB0,W
                BTFSS           _C
                INCFSZ          BARGB0,W
                SUBWF           REMB0, F
                GOTO            UOK35L8

UADD35L8        ADDWF           REMB1, F
                MOVF            BARGB0,W
                BTFSC           _C
                INCFSZ          BARGB0,W
                ADDWF           REMB0, F
        
UOK35L8 	RLF             AARGB1, F

                MOVLW           7
                MOVWF           LOOPCOUNT

LOOPU2315B      RLF             AARGB1,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB1,LSB
                GOTO            UADD35LB

                SUBWF           REMB1, F
                MOVF            BARGB0,W
                BTFSS           _C
                INCFSZ          BARGB0,W
                SUBWF           REMB0, F
                GOTO            UOK35LB

UADD35LB        ADDWF           REMB1, F
                MOVF            BARGB0,W
                BTFSC           _C
                INCFSZ          BARGB0,W
                ADDWF           REMB0, F
        
UOK35LB 	RLF             AARGB1, F

                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU2315B

                RLF             AARGB2,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB1,LSB
                GOTO            UADD35L16

                SUBWF           REMB1, F
                MOVF            BARGB0,W
                BTFSS           _C
                INCFSZ          BARGB0,W
                SUBWF           REMB0, F
                GOTO            UOK35L16

UADD35L16       ADDWF           REMB1, F
                MOVF            BARGB0,W
                BTFSC           _C
                INCFSZ          BARGB0,W
                ADDWF           REMB0, F
        
UOK35L16        RLF             AARGB2, F

                MOVLW           7
                MOVWF           LOOPCOUNT

LOOPU2315C      RLF             AARGB2,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB2,LSB
                GOTO            UADD35LC

                SUBWF           REMB1, F
                MOVF            BARGB0,W
                BTFSS           _C
                INCFSZ          BARGB0,W
                SUBWF           REMB0, F
                GOTO            UOK35LC

UADD35LC        ADDWF           REMB1, F
                MOVF            BARGB0,W
                BTFSC           _C
                INCFSZ          BARGB0,W
                ADDWF           REMB0, F
        
UOK35LC 	RLF             AARGB2, F

                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU2315C

                BTFSC           AARGB2,LSB
                GOTO            UOK35L
                MOVF            BARGB1,W
	        ADDWF           REMB1, F
                MOVF            BARGB0,W
                BTFSC           _C
                INCFSZ          BARGB0,W
                ADDWF           REMB0, F
UOK35L

                endm

;**********************************************************************************************
;**********************************************************************************************
;       16x8 Bit Unsigned Fixed Point Multiply 16x8 -> 24
;       Input:  16 bit unsigned fixed point multiplicand in AARGB0
;                       8 bit unsigned fixed point multiplier in BARGB0
;       Use:    CALL    FXM1608U
;       Output: 24 bit unsigned fixed point product in AARGB0
;       Result: AARG  <--  AARG x BARG
;       Max Timing:     5+119+2 = 126 clks
;       Min Timing:     5+54 = 59 clks
;       PM: 5+26+1 = 31              DM: 7
;**********************************************************************************************

FXM1608U:
        CLRF	AARGB2			; clear partial product
        MOVF   	AARGB0,W
        MOVWF   TEMPB0
        MOVF   	AARGB1,W
        MOVWF   TEMPB1

        UMUL1608L

        RETLW           0x00

;**********************************************************************************************
;**********************************************************************************************
;       23/15 Bit Unsigned Fixed Point Divide 23/15 -> 23.15
;       Input:  23 bit unsigned fixed point dividend in AARGB0, AARGB1,AARGB2
;               15 bit unsigned fixed point divisor in BARGB0, BARGB1
;       Use:    CALL    FXD2315U
;       Output: 23 bit unsigned fixed point quotient in AARGB0, AARGB1,AARGB2
;               15 bit unsigned fixed point remainder in REMB0, REMB1
;       Result: AARG, REM  <--  AARG / BARG
;       Max Timing:     2+403+2 = 407 clks
;       Min Timing:     2+375+2 = 379 clks
;       PM: 2+117+1 = 120               DM: 7
;**********************************************************************************************

FXD2315U        CLRF            REMB0
                CLRF            REMB1

                UDIV2315L

                RETLW           0x00
